unit uFrmCount;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, uCountThread;

type
  TFrmCount = class(TForm)
    memMsg: TMemo;
    edtNum: TEdit;
    btnAsc: TButton;
    btnDesc: TButton;
    btnStop: TButton;
    btnExitThread: TButton;
    Label1: TLabel;
    memInfo: TMemo;
    procedure btnAscClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnDescClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure btnExitThreadClick(Sender: TObject);
  private

    FCountThread: TCountThread;
    procedure OnCountNum(Sender: TCountThread; ANum: integer);

    procedure DispMsg(AMsg: string);
    procedure OnThreadMsg(AMsg: string);
  public

  end;

var
  FrmCount: TFrmCount;

implementation

{$R *.dfm}
{ TFrmCount }

procedure TFrmCount.btnAscClick(Sender: TObject);
begin

  // Ϊ̶߳߳Ҫ CountAction
  // ʴ˼ Lock
  // 򵥣Ҳ,ʵʹҪע

  FCountThread.Lock;
  try
    FCountThread.CountAction := caAsc;
  finally
    FCountThread.Unlock;
  end;

  // ťд lock
  // ʵ԰ CountAction װ, SetCountAction м lock 
  // ֪ʶҲοд˴Թ


  //  lock ҪעȵĴС
  //  win ̣ݱ̣Ӧע
  // κʱ򣬶Ӧ lock ӰıԴٻȷ̵߳Чʡ
  // һ lock ̫ܵô߳̽ʧȥ壬˴ִˡҲǵ߳ˡ
  // ֻһ䣬õʱԻס

end;

procedure TFrmCount.btnDescClick(Sender: TObject);
begin
  FCountThread.Lock;
  try
    FCountThread.CountAction := caDesc;
  finally
    FCountThread.Unlock;
  end;

end;

procedure TFrmCount.btnExitThreadClick(Sender: TObject);
begin
  FCountThread.Terminate;
  // ˾þ Terminated:=true;
  // ڹرձǰִһ´˴롣
  // صĴ󣬹
end;

procedure TFrmCount.btnStopClick(Sender: TObject);
begin
  FCountThread.Lock;
  try
    FCountThread.CountAction := caStop;
  finally
    FCountThread.Unlock;
  end;
end;

procedure TFrmCount.DispMsg(AMsg: string);
begin
  if memMsg.Lines.Count > 1000 then
    memMsg.Clear;
  memMsg.Lines.Add(AMsg);
end;

procedure TFrmCount.FormCreate(Sender: TObject);
begin
  FCountThread := TCountThread.Create;
  // һ߳ʵͻִ
  // ʶòѲд create 

  // ᣬ¼ֵ

  FCountThread.OnMsg := self.OnThreadMsg;
  FCountThread.OnCountNum := self.OnCountNum;
  // ̵߳¼ָʵֹ̡
end;

procedure TFrmCount.FormDestroy(Sender: TObject);
begin
  FCountThread.Terminate;
  sleep(100);
  // 벻淶˵ϵ "˳ execute ť
  // ԣʵʹУø׼ȷķ
  FCountThread.Free;
end;

procedure TFrmCount.OnCountNum(Sender: TCountThread; ANum: integer);
begin
  // ̴߳룬ʰѷ editNum ߳
  tthread.Synchronize(nil,
    procedure
    begin
      edtNum.Text := IntToStr(ANum);
    end);
end;

procedure TFrmCount.OnThreadMsg(AMsg: string);
begin
  tthread.Queue(nil,
    procedure
    begin
      DispMsg(AMsg);
    end);
end;

end.
